#ifndef SHDRGLOB_H
#define SHDRGLOB_H
/****************************************************************************

FILE	shdrglob.h

PURPOSE 
    	This file contains declarations, which are used by POV-Ray and 
    	shading language compiler.
*****************************************************************************/
/*****************************************************************************                                                                              
 Copyright (c) 1995
      Robert J. Mercier
 Copyright 2000
      Vahur Krouverk

THIS CODE IS SUPPLIED ``AS IS'' WITH NO WARRANTY EXPRESSED
OR IMPLIED.  NO CLAIMS IS MADE TO IT'S SUITABILITY FOR
ANY PURPOSE AND NO RESPONSIBILITY IS ACCEPTED FOR ANY DAMAGES
OF ANY KIND RESULTING FROM IT'S USE.

When (if) this code is included into POV the usual POV legal stuff will apply.

*****************************************************************************/

#define SHADER_PRODUCT_STRING "povslc"
#define SHADER_VERSION_MAJOR 0
#define SHADER_VERSION_MINOR 3

#define SHADER_TYPE_SURFACE      0
#define SHADER_TYPE_ISO_FUNCTION 1

/* transformation types */
#define POINT_TRANSFORM   1
#define NORMAL_TRANSFORM  2
#define VECTOR_TRANSFORM  3

#define PS_RASTER 1
#define PS_SCREEN 2
#define PS_CAMERA 3
#define PS_WORLD  4
#define PS_OBJECT 5
#define PS_SHADER 6
#define PS_NDC    7

/* default current point space is world, as in BMRT */
#define PS_CURRENT 4

/* spline type definitions */
#define SP_CATMULL_ROM 1
#define SP_BEZIER      2
#define SP_BSPLINE     3
#define SP_HERMITE     4
#define SP_LINEAR      5

/* data offset in data stack for built-in parameters */
#define Cs_DA_OFFS          0
#define Os_DA_OFFS          3
#define P_DA_OFFS           6
#define N_DA_OFFS           9
#define Ng_DA_OFFS         12
#define I_DA_OFFS          15
#define Ci_DA_OFFS         18
#define Oi_DA_OFFS         21
#define s_DA_OFFS          24
#define t_DA_OFFS          25
#define u_DA_OFFS          26
#define v_DA_OFFS          27
#define du_DA_OFFS         28
#define dv_DA_OFFS         29
#define time_DA_OFFS       30
#define E_DA_OFFS          31
#define Cl_DA_OFFS         34
#define L_DA_OFFS          37
#define As_DA_OFFS         40
#define iso_val_DA_OFFS    43
#define BUILTIN_MAX_OFFS   44



#endif
